@echo off
rem ###########################################################################
rem ##                                                                       ##
rem ##  D B T U T O O L S / D B T U G E T S S . B A T                        ##
rem ##                                                                       ##
rem ## --------------------------------------------------------------------- ##
rem ##                                                                       ##
rem ##  Job .......: Script for collecting all snapshot data for a database. ##
rem ##                                                                       ##
rem ## --------------------------------------------------------------------- ##
rem ##                                                                       ##
rem ##  Copyright (C) 2002  Daniel Scheibli                                  ##
rem ##                                                                       ##
rem ##  This program is free software; you can redistribute it and/or        ##
rem ##  modify it under the terms of the GNU General Public License as       ##
rem ##  published by the Free Software Foundation; either version 2 of       ##
rem ##  the License, or (at your option) any later version.                  ##
rem ##                                                                       ##
rem ##  This program is distributed in the hope that it will be useful,      ##
rem ##  but WITHOUT ANY WARRANTY; without even the implied warranty of       ##
rem ##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        ##
rem ##  GNU General Public License for more details.                         ##
rem ##                                                                       ##
rem ##  You should have received a copy of the GNU General Public License    ##
rem ##  along with this program; if not, write to the Free Software          ##
rem ##  Foundation, Inc., 59 Temple Place - Suite 330, Boston,               ##
rem ##  MA 02111-1307, USA.                                                  ##
rem ##                                                                       ##
rem ## --------------------------------------------------------------------- ##
rem ##                                                                       ##
rem ##  Remark ....: - In opposite to the less tool, the more command of     ##
rem ##                 Windows is very limited.                              ##
rem ##                                                                       ##
rem ## --------------------------------------------------------------------- ##
rem ##                                                                       ##
rem ##  Author ....: Daniel Scheibli <daniel.scheibli@edelbyte.org>          ##
rem ##  Date ......: 2002-12-30                                              ##
rem ##  Changes ...: ----- dbtugetss.bat V00.99/R020 ----------------------- ##
rem ##               <none>                                                  ##
rem ##                                                                       ##
rem ###########################################################################



rem ##### Presettings (global)
rem #--------------------------------------------------------------------------
set XX1PPID=
for /F "Tokens=*" %%I in ('dbtuapiwrapper.exe --request core.os.system.getprocessid --level 2 2>NUL') do set XX1PPID=%%I
rem #- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
rem ##### On error,...
if "%XX1PPID%" == "" (
 echo.
 echo ===^> ERROR: The current Process Id could not retrieved.
 echo.
 goto Exit
)
rem #- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
set XX1FILE=.\dbtugetss.out.%XX1PPID%
rem #--------------------------------------------------------------------------



rem ##### Presettings
rem #--------------------------------------------------------------------------
echo.
echo DBTUGETSS.BAT V00.99/R020
echo.
rem #--------------------------------------------------------------------------



rem ##### Process the given arguments
rem #--------------------------------------------------------------------------
set XX1ARGS=0
if not "%1" == "" set XX1ARGS=1
if not "%2" == "" set XX1ARGS=2
rem #- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
if not "%XX1ARGS%" == "1" (
 echo ===^> ERROR: A minimum of one argument was expected.
 echo.
 echo Usage .......: ^>^>--- dbtugetss.bat --- ALIAS ---^>^<
 echo.
 echo Sample ......: dbtugetss.bat sample
 echo.
 echo Arguments ...: ALIAS   The alias of the database the
 echo                        snapshot should be taken for.
 echo.
 goto Exit
)
rem #--------------------------------------------------------------------------



rem ##### Activate all monitor switches
rem #--------------------------------------------------------------------------
echo Activate monitor switches...
rem #- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
db2 UPDATE MONITOR SWITCHES USING BUFFERPOOL ON 1>NUL
db2 UPDATE MONITOR SWITCHES USING LOCK       ON 1>NUL
db2 UPDATE MONITOR SWITCHES USING SORT       ON 1>NUL
db2 UPDATE MONITOR SWITCHES USING STATEMENT  ON 1>NUL
db2 UPDATE MONITOR SWITCHES USING TABLE      ON 1>NUL
db2 UPDATE MONITOR SWITCHES USING UOW        ON 1>NUL
rem #--------------------------------------------------------------------------



rem ##### Get snapshot for the DBM and the given database
rem #--------------------------------------------------------------------------
echo Collect snapshot data...
rem #- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
echo y | copy NUL %XX1FILE% 1>NUL
db2 GET SNAPSHOT FOR DBM       1>>%XX1FILE%
db2 GET SNAPSHOT FOR ALL ON %1 1>>%XX1FILE%
rem #--------------------------------------------------------------------------



rem ##### Get snapshot for the DBM and the given database
rem #--------------------------------------------------------------------------
echo Show snapshot data...
rem #- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
more /E %XX1FILE%
echo.
rem #--------------------------------------------------------------------------



rem ##### End of program
rem #--------------------------------------------------------------------------
:Exit
rem #--------------------------------------------------------------------------


