/* ######################################################################### */
/* ##                                                                     ## */
/* ##  D B T U T O O L S / D B T U F F 2 C O D E . J A V A                ## */
/* ##                                                                     ## */
/* ## ------------------------------------------------------------------- ## */
/* ##                                                                     ## */
/* ##  Job .......: Tool for interpreting the hex representation of       ## */
/* ##               DB2 internal error codes.                             ## */
/* ##                                                                     ## */
/* ## ------------------------------------------------------------------- ## */
/* ##                                                                     ## */
/* ##  Copyright (C) 2002  Daniel Scheibli                                ## */
/* ##                                                                     ## */
/* ##  This program is free software; you can redistribute it and/or      ## */
/* ##  modify it under the terms of the GNU General Public License        ## */
/* ##  as published by the Free Software Foundation; either version 2     ## */
/* ##  of the License, or (at your option) any later version.             ## */
/* ##                                                                     ## */
/* ##  This program is distributed in the hope that it will be useful,    ## */
/* ##  but WITHOUT ANY WARRANTY; without even the implied warranty of     ## */
/* ##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      ## */
/* ##  GNU General Public License for more details.                       ## */
/* ##                                                                     ## */
/* ##  You should have received a copy of the GNU General Public License  ## */
/* ##  along with this program; if not, write to the Free Software        ## */
/* ##  Foundation, Inc., 59 Temple Place - Suite 330, Boston,             ## */
/* ##  MA  02111-1307, USA.                                               ## */
/* ##                                                                     ## */
/* ## ------------------------------------------------------------------- ## */
/* ##                                                                     ## */
/* ##  Remark ....: <none>                                                ## */
/* ##                                                                     ## */
/* ## ------------------------------------------------------------------- ## */
/* ##                                                                     ## */
/* ##  Author ....: Daniel Scheibli <daniel.scheibli@edelbyte.org>        ## */
/* ##  Date ......: 2002-04-25                                            ## */
/* ##  Changes ...: ----- dbtuff2code.java V00.99/R020 ------------------ ## */
/* ##               <none>                                                ## */
/* ##               ----- dbtuff2code.java V00.99/R011 ------------------ ## */
/* ##               2002-09-16 - Renamed the package hosting this class   ## */
/* ##                            (was org.edelbyte.DbtuTools).            ## */
/* ##               ----- dbtuff2code.java V00.99/R010 ------------------ ## */
/* ##               2002-08-09 - Port from C to Java.                     ## */
/* ##               ----- dbtuff2code.c V00.99/R002 --------------------- ## */
/* ##               2002-05-12 - Shift to central headerfile.             ## */
/* ##               2002-05-07 - Change from printf() to fprintf().       ## */
/* ##               ----- dbtuff2code.c V00.99/R001 --------------------- ## */
/* ##               <none>                                                ## */
/* ##                                                                     ## */
/* ######################################################################### */



/* ##### Presettings */
/* ------------------------------------------------------------------------- */
package org.dbtutools.DbtuTools;
/* ------------------------------------------------------------------------- */





/* ##### Class definition */
/* ------------------------------------------------------------------------- */
public class dbtuff2code
{
 /* ######################################################################## */
 /* ##                                                                    ## */
 /* ##   < M A I N >                                                      ## */
 /* ##                                                                    ## */ 
 /* ######################################################################## */
 public static void main( java.lang.String aoArgs[] )
 {
  /* ##### Presettings */
  /* ----------------------------------------------------------------------- */
  java.lang.String       oInternalReturnCode = new java.lang.String();
  int                    iSqlCode            = 0;
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  java.text.NumberFormat oFormatObject       = new java.text.DecimalFormat("0000");
  /* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
  int                    iProgRc = 0;
  /* ----------------------------------------------------------------------- */  



  /* ##### "Prevent nested IF's"-Loop */
  /* ----------------------------------------------------------------------- */  
  LOOP1: for(;;)
  {
   /* ##### Check the given arguments */
   /* ---------------------------------------------------------------------- */
   if( aoArgs.length != 2 )
   {
    java.lang.System.err.println( "" );
    java.lang.System.err.println( "===> ERROR: A minimum of two arguments was expected." );
    (new java.lang.Exception("Error location")).printStackTrace();
    java.lang.System.err.println( "" );
    java.lang.System.err.println( "Usage .......: >>--- dbtuff2code --- STRING1 --- STRING2 ---><" );
    java.lang.System.err.println( "" );
    java.lang.System.err.println( "Sample ......: dbtuff2code ffff e60a" );
    java.lang.System.err.println( "" );
    java.lang.System.err.println( "Arguments ...: STRING1   The first 4 hexdigit strings found in" );
    java.lang.System.err.println( "                         the db2diag.log file." );    
    java.lang.System.err.println( "               STRING2   The second 4 hexdigit strings found in" );
    java.lang.System.err.println( "                         the db2diag.log file." );    
    java.lang.System.err.println( "" );
    iProgRc = 1;
    break LOOP1;
   }
   /* ---------------------------------------------------------------------- */



   /* ##### Do conversion */
   /* ---------------------------------------------------------------------- */
   try
   {
    oInternalReturnCode = org.dbtutools.DbtuTools.core.db2.DiagLog.toInternalReturnCode( aoArgs[0], aoArgs[1] );
    iSqlCode            = org.dbtutools.DbtuTools.core.db2.DiagLog.toSqlCode( aoArgs[0], aoArgs[1] );    
   }
   catch( java.lang.NumberFormatException oException )
   {
    java.lang.System.err.println( "" );
    java.lang.System.err.println( "===> ERROR: Conversion failed." );
    oException.printStackTrace();    
    java.lang.System.err.println( "" );
    iProgRc = 1;
    break LOOP1;    
   }
   /* ---------------------------------------------------------------------- */
  


   /* ##### Print result */
   /* ---------------------------------------------------------------------- */
   /* ##### TODO: The next step would be to check wether it is a.) or b.) */
   /* #####       and display the appendant part of the documentation.    */
   if( oInternalReturnCode.compareTo(org.dbtutools.DbtuTools.core.db2.DiagLog.FFFF_TOKEN) == 0 )
   {
    java.lang.System.out.println( "" );
    java.lang.System.out.println( "This special hexdigit string combination stands for an undefined error." );
    java.lang.System.out.println( "" );
   }
   else
   {
    java.lang.System.out.println( "" );
    java.lang.System.out.println( "The hexdigit string combination stands for" );
    java.lang.System.out.println( "a.) SQL Message 'SQL" + oFormatObject.format(java.lang.Math.abs(iSqlCode)) + ((iSqlCode < 0) ? "N" : "W") + "'          (see Message Reference)" );
    java.lang.System.out.println( "b.) DB2 Internal Return Code '" + oInternalReturnCode.toString() + "' (see Troubleshooting Guide)" );
    java.lang.System.out.println( "" );
   }
   /* ---------------------------------------------------------------------- */
  

  
   /* ##### Leave "Prevent nested IF's"-Loop */
   break LOOP1;
  }
  /* ----------------------------------------------------------------------- */    
  
  
  
  /* ##### End of program */
  /* ----------------------------------------------------------------------- */  
  java.lang.System.exit( iProgRc );
  /* ----------------------------------------------------------------------- */  
 }
}
/* ------------------------------------------------------------------------- */




